#ifndef _LOGOUT_H_
#define _LOGOUT_H_

#define IOCTL_LOGO_COUNT		CTL_CODE( FILE_DEVICE_UNKNOWN, 0x810, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define IOCTL_LOGO_DATA			CTL_CODE( FILE_DEVICE_UNKNOWN, 0x811, METHOD_BUFFERED, FILE_ANY_ACCESS )

#define PROCESSNAMESIZE 200
#define DOCUMENTSIZE 1000
#define BYPASS 1
#define CANNOT 2
#define ACCESS 3
#define MAXLOGOTEXTSIZE 100
#define MAXLOGOENTRY 100
#define WCHARTYPE 1
#define ASCIITYPE 2

#define MAXLISTENTRY 100

#define DEVICEIOCONTROL_MAXLOGOCOUNT 100

typedef struct
{
	LONGLONG dwAccessTime; // ٽð
	ULONG ProcessId; // μID
	ULONG AccessResult; // ٱ⺻
	ULONG CharType; // Reserved
	char LogoText[MAXLOGOTEXTSIZE]; // LOGO Title
	char ProcessName[PROCESSNAMESIZE]; // μ̸
	char FullDocumentName[DOCUMENTSIZE]; // ٱλ
} LOGOENTRY, * PLOGOENTRY;

void InputLogo( 
	char * LogoText, 
	ULONG ProcessId, 
	char * ProcessName, 
	char * Document, 
	int dwSize, 
	ULONG Att 
	);

ULONG 
GetProcessNameOffset(
	VOID
	);

char *
GetProcess( 
	char * ProcessName 
	);

void GetProcessName( 
	char * pProcess 
	);

void cUpper(
	UCHAR *str
	);

#endif // _LOGOUT_H_

