#include <ntddk.h>

#ifndef _QUEUE_H_
#define _QUEUE_H_

#define MAXIMUMQUEUESIZE 0x40000
	typedef struct _QUEUE_
	{
		unsigned long dwType;
		unsigned long dwHead;
		unsigned long dwTail;
		unsigned char Queue[MAXIMUMQUEUESIZE+1];
	}HAJE_QUEUE, * PHAJE_QUEUE;

	unsigned char * allocmem( unsigned long dwSize );
	void freemem( unsigned char * pBuffer );
	void Prolog( KIRQL * pIrql );
	void Epilog( KIRQL Irql );
	unsigned long SizeofQueue( PHAJE_QUEUE pQueue );
	PHAJE_QUEUE AllocateQueue();
	void FreeQueue( PHAJE_QUEUE pQueue );
	unsigned long InputQueue( PHAJE_QUEUE pQueue, unsigned char *DataBuffer, unsigned long dwSize );
	unsigned long OutputQueue( PHAJE_QUEUE pQueue, unsigned char *DataBuffer, unsigned long dwSize );
	void ResetQueue( PHAJE_QUEUE pQueue );
	unsigned long InputQueueWithoutNoPointerChange( PHAJE_QUEUE pQueue, unsigned char *DataBuffer, unsigned long dwSize );
	unsigned long OutputQueueWithoutNoPointerChange( PHAJE_QUEUE pQueue, unsigned char *DataBuffer, unsigned long dwSize );

#endif //_QUEUE_H_

